#!/usr/bin/bash

version="4.2.2.Final"
name="eclipse-jbosstools"

MODULES="jbosstools-base \
         jbosstools-build \
         jbosstools-build-sites \
         jbosstools-freemarker \
         jbosstools-javaee \
         jbosstools-jst \
         jbosstools-openshift \
         jbosstools-server \
         jbosstools-webservices"

# Where possible, commit SHAs based on stable Git tag
declare -A commits
commits[jbosstools-base]="a6dedd51bcd26ea9e209d198ffd03caa87fdadb7"
commits[jbosstools-build]="c3609bdb1ab7a9bddd5428d107591d30d4a31278"
commits[jbosstools-build-sites]="419b62ede9a7dc06491febb801e59e6832e31b40"
commits[jbosstools-freemarker]="122ec093384398084a63cd058a1e1671f641c0d1"
commits[jbosstools-javaee]="46ab81732aaef96bfdf65c1b463b39c532737a4b"
commits[jbosstools-jst]="f2677a0fbc5fcba5a00b6c57fb981299d79c3724"
commits[jbosstools-openshift]="e3e0b51caa11ca8d6d00ca8b769ec7341ddda7de"
commits[jbosstools-server]="1108d9f3a76620436dce43b375d8b71a85a0032e"
commits[jbosstools-webservices]="7329c379638dde9aded65a7787249846a97742e4"

mkdir ${name}-${version}/

for module in ${MODULES}; do
  wget https://github.com/jbosstools/${module}/archive\
/${commits[${module}]}/${module}-${version}.tar.gz
done

pushd ${name}-${version}
  for module in ${MODULES}; do
    tar xfz ../${module}-${version}.tar.gz
    mv ${module}-${commits[${module}]} ${module}
  done

  for ext in jar war zip class; do
    find -type f -name *.${ext} -delete
  done
popd

tar cJf ${name}-${version}.tar.xz ${name}-${version}/
rm -r ${name}-${version}

for module in ${MODULES}; do
  rm ${module}-${version}.tar.gz
done
