%global eclipse_dropins %{_datadir}/eclipse/dropins
%global build_base      jbosstools-build-sites/aggregate/local-site/.m2/org/jboss/tools/
%global rls_tag         Final

Name:           eclipse-jbosstools
Version:        4.2.2
Release:        1%{?dist}
Summary:        Eclipse plugins that support JBoss and related technology

# For mult. license info, see https://community.jboss.org/thread/158037
License:        EPL and LGPLv2+ and ASL 2.0
URL:            http://tools.jboss.org

# Steps to create this are found in create-tarball.sh
Source0:        %{name}-%{version}.%{rls_tag}.tar.xz

Source1:        LICENSE-2.0.txt
Source2:        lgpl-2.1.txt
Source3:        create-tarball.sh

# feature.xml patch to remove 'requires' section - fails because of the way we
# have wtp packages set up currently - not all have same qualifier.
Patch10:        %{name}-ws-rm-requires.patch

# fix classpath entry to unversioned freemarker.jar (symlinked from _javadir)
Patch12:        %{name}-freemarker-4.0.0.patch

# Update refs from old bundled deps in archives, to symlinked deps from Fedora
Patch14:        %{name}-archives-core-manifest-4.0.0.patch
Patch15:        %{name}-archives-core-buildproperties-4.0.0.patch

# Migrate to from obselete to current version of TrueZip dependency
Patch16:        %{name}-archives-core-trueziputil-4.0.0.patch
Patch17:        %{name}-archives-core-modeltruezipbridge.patch
Patch18:        %{name}-archives-core-archivesbuilder.patch
Patch19:        %{name}-as-archives.webtools-4.0.0.patch
Patch28:        %{name}-archives-core-plugin.patch

# Update refs from old bundled deps in AS, to symlinked deps from Fedora
Patch21:        %{name}-as.dmr-4.0.0.patch
Patch22:        %{name}-as.core.patch
Patch23:        %{name}-as.mgmt.as71-4.0.0.patch

# Update refs from bundled deps in Openshift, to symlinked deps from Fedora
Patch24:        %{name}-openshift-bundledjarnames.patch

# Use unversioned deps in org.jboss.tools.ws.wise.ui
Patch25:        %{name}-ws.wise.ui-deps.patch

# Patch incompatibilities between lucene3 and lucene4
Patch26:        %{name}-lucene-api-migration.patch
Patch27:        %{name}-lucene-api-migration2.patch

# Some egit classes are moved in 3.5.0
Patch29:        %{name}-openshift-egit-class-move.patch

# Require-Bundle swt-chart, rather than bundling
Patch30:        %{name}-jvmmonitor-swt-chart.patch

BuildArch:      noarch

BuildRequires:  ant >= 1.8.4
BuildRequires:  ant-contrib >= 1.0
BuildRequires:  apache-commons-codec >= 1.6
BuildRequires:  axis >= 1.4-16
BuildRequires:  dom4j >= 1.6.1-8
BuildRequires:  eclipse-dtp >= 1.10
BuildRequires:  eclipse-egit >= 3.0.0
BuildRequires:  eclipse-emf-core >= 2.8.1
BuildRequires:  eclipse-gef >= 3.8.0
BuildRequires:  eclipse-jdt >= 4.4.1
BuildRequires:  eclipse-m2e-core >= 1.4.0
BuildRequires:  eclipse-mylyn >= 3.9.0
BuildRequires:  eclipse-p2-discovery >= 4.4.1
BuildRequires:  eclipse-pde >= 4.4.1
BuildRequires:  eclipse-platform >= 4.4.1
BuildRequires:  eclipse-rse >= 3.4
BuildRequires:  eclipse-swt >= 4.3.0
BuildRequires:  eclipse-webtools-dali >= 3.6.0
BuildRequires:  eclipse-webtools-jsf >= 3.6.0
BuildRequires:  git
BuildRequires:  gnu-getopt >= 1.0.13
BuildRequires:  icu4j-eclipse >= 4.4.2.2
BuildRequires:  jacoco-maven-plugin
BuildRequires:  jakarta-commons-httpclient >= 3.1
BuildRequires:  java-devel
BuildRequires:  jaxen >= 1.1.3
BuildRequires:  wildfly
BuildRequires:  jboss-dmr >= 1.1.1
BuildRequires:  jpackage-utils
BuildRequires:  maven-local
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  objectweb-asm
BuildRequires:  openshift-java-client >= 2.5.0
BuildRequires:  resteasy >= 2.3.2-7
BuildRequires:  truezip-driver-zip >= 7.6.6
BuildRequires:  truezip-file >= 7.6.6
BuildRequires:  tycho
BuildRequires:  tycho-extras
BuildRequires:  velocity >= 1.7-4
BuildRequires:  xerces-j2 >= 2.11.0-11
BuildRequires:  xpp3-minimal
BuildRequires:  mvn(org.jboss.jdf:stacks-client)
BuildRequires:  mvn(org.jboss.wise:wise-core)
BuildRequires:  mvn(org.jboss.wise:wise-core-cxf)
BuildRequires:  mvn(org.jboss.ws:jbossws-parent:pom:)
BuildRequires:  swt-chart
BuildRequires:  log4j12

Requires:       jpackage-utils

Requires:       %{name}-archives = %{version}-%{release}
Requires:       %{name}-as = %{version}-%{release}
Requires:       %{name}-cdi = %{version}-%{release}
Requires:       %{name}-common = %{version}-%{release}
Requires:       %{name}-freemarker = %{version}-%{release}
Requires:       %{name}-jmx = %{version}-%{release}
Requires:       %{name}-jst = %{version}-%{release}
Requires:       %{name}-openshift = %{version}-%{release}
Requires:       %{name}-runtime = %{version}-%{release}
Requires:       %{name}-usage = %{version}-%{release}
Requires:       %{name}-ws = %{version}-%{release}

%description
JBoss Tools is an umbrella project for a set of Eclipse plugins that supports
JBoss and related technology; there is support for Hibernate, JBoss AS, Drools, 
jBPM, JSF, (X)HTML, Seam, Maven, JBoss ESB, JBoss Portal and more...

%package        common
Summary:        JBoss Tools common Eclipse tools

%description common
Common functionality on which other plugins and features from
%{name} depend.

%package        jmx
Summary:        Eclipse tools for interacting with JMX connections
Obsoletes:      %{name}-server

%description jmx
JBoss JMX Tools allows you to setup multiple JMX connections, and provides a
view for exploring the JMX tree and execute operations directly from within
Eclipse.

%package        archives
Summary:        JBoss Archives Tools
Obsoletes:      %{name}-parent
Obsoletes:      %{name}-server

%description archives
Project Archives provides a way to define archives based on include/exclude
filesets which then gets incrementally updated allowing for fluent
deployment for any type of Eclipse project.

%package        usage
Summary:        JBoss Tools Usage Reporting
Obsoletes:      %{name}-base
Obsoletes:      %{name}-parent

%description usage
JBoss Tools Usage reporting provides an anonymous opt-in call-back mechanism
that can be used to see how widely used plugins are, which plugin installations
have been done, where in the world and what versions of operating system, java
and other information that is available.

%package        as
Summary:        JBossAS Tools

Requires:       wildfly
Requires:       jboss-sasl
Requires:       jboss-threads
Requires:       jboss-remoting
Requires:       jboss-marshalling

%description as
Provides WTP server adapters for JBoss installations. These adapters are 
capable of deployment and providing classpaths for projects. Zipped or
exploded deployments, JMX integration, and other extensions are included.

%package        jst
Summary:        JBoss Tools Java Standard Tools

%description jst
JBoss Tools Java Standard Tools provides common tools for use in JBoss Tools
other plugins, such as Knowledge Base builder and validators for use in JSF/Web
projects.

%package        ws
Summary:        JBoss WebServices Tools and JBoss JAX-RS Tools

Requires:       resteasy
Requires:       avalon-logkit
Requires:       avalon-framework
Requires:       cxf
Requires:       cxf-xjc-utils
Requires:       dtdparser
Requires:       opencsv
Requires:       wise-core
Requires:       wise-core-cxf

%description ws
JBoss WebServices Tools provides wizards for working with webservices
and a webservice tester view to test out both SOAP and REST services.

JBoss JAX-RS Tools provides a common navigator to browse and introspect
your JAX-RS endpoints and provide validation for JAX-RS annotations, such
as checking that parameters referenced by name actually also are declared.

%package        cdi
Summary:        JBoss CDI Tools, Apache Deltasipke Tools, Seam 3 Tools
Obsoletes:      %{name}-javaee

%description cdi
Context and Dependency Injection Tools provides support for JSR-299 also know
as CDI. Adds wizards, code navigation, validation and quickfixes to work with
projects that uses CDI.

Apache Deltasipke Tools provides tooling for the CDI components released as
part of Deltaspike modules.

Seam 3 Tools provides tooling for the CDI components released as part of
Seam 3 modules such as Solder and Config. Tooling covers recognizing
these CDI components and editing the seam config xml.

%package        freemarker
Summary:        FreeMarker IDE

Requires:       freemarker

%description freemarker
FreeMarkerIDE provides editor for FreeMarker templates

%package        runtime
Summary:        JBoss Runtime Detection

%description runtime
JBoss Runtime Detection

%package openshift
Summary:        JBoss Openshift Tools for Eclipse

Requires:       jboss-dmr
Requires:       slf4j-log4j12
Requires:       openshift-java-client

%description openshift
OpenShift Tools provides wizards and views for
creating and maintaining OpenShift applications.

%package        foundation
Summary:        JBoss Tools Foundation
Obsoletes:      %{name}-base
Obsoletes:      %{name}-parent

%description foundation
%{summary} provides utility classes and infrastructure for all other
plugins.

%package        stacks
Summary:        JBoss Stacks Tools

%description stacks
JBoss Stacks consumer which helps provide models for use by other
plugins.

%prep
%setup -q -n %{name}-%{version}.%{rls_tag}

cp %{SOURCE1} %{SOURCE2} .

find -name '*.jar' -delete
find -name '*.class' -delete

# add symlinks to Fedora versions of removed jars
pushd jbosstools-server/archives/plugins/org.jboss.ide.eclipse.archives.core/lib/
ln -s %{_javadir}/truezip/truezip-driver-file.jar
ln -s %{_javadir}/truezip/truezip-driver-zip.jar
ln -s %{_javadir}/truezip/truezip-file.jar
ln -s %{_javadir}/truezip/truezip-kernel.jar
popd
pushd jbosstools-server/as/plugins/org.jboss.ide.eclipse.as.dmr/
ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
popd
pushd jbosstools-server/as/plugins/org.jboss.ide.eclipse.as.core/
ln -s %{_javadir}/dom4j.jar
ln -s %{_javadir}/jaxen.jar
ln -s %{_javadir}/gnu-getopt.jar
popd
pushd jbosstools-server/as/plugins/org.jboss.ide.eclipse.as.management.as71/
ln -s %{_javadir}/wildfly/wildfly-controller-client.jar
ln -s %{_javadir}/wildfly/wildfly-protocol.jar
ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
ln -s %{_javadir}/jboss-logging/jboss-logging.jar
ln -s %{_javadir}/jboss-marshalling/jboss-marshalling.jar
ln -s %{_javadir}/jboss-marshalling/jboss-marshalling-river.jar
ln -s %{_javadir}/jboss-remoting/jboss-remoting.jar
ln -s %{_javadir}/jboss-sasl/jboss-sasl.jar
ln -s %{_javadir}/jboss-threads/jboss-threads.jar
ln -s %{_javadir}/xnio/xnio-api.jar
ln -s %{_javadir}/xnio/xnio-nio.jar
popd
pushd jbosstools-webservices/plugins/org.jboss.tools.ws.ui/lib/
ln -s %{_javadir}/axis/axis.jar
ln -s %{_javadir}/axis/jaxrpc.jar
ln -s %{_javadir}/resteasy/jaxrs-api.jar
popd
pushd jbosstools-freemarker/plugins/org.jboss.ide.eclipse.freemarker/
ln -s %{_javadir}/freemarker.jar
popd
pushd jbosstools-openshift/plugins/org.jboss.tools.openshift.express.client/
mkdir lib && pushd lib/
ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
ln -s %{_javadir}/log4j12-1.2.17.jar log4j.jar
ln -s %{_javadir}/openshift-java-client/openshift-java-client.jar
ln -s %{_javadir}/slf4j/api.jar slf4j-api.jar
ln -s %{_javadir}/slf4j/log4j12.jar slf4j-log4j12.jar
popd
popd

# Remove custom repository-utils plugin from parent pom
%pom_remove_plugin org.jboss.tools.tycho-plugins:repository-utils jbosstools-build/parent

# Remove jacoco plugin -- broken in rawhide
%pom_remove_plugin org.jacoco:jacoco-maven-plugin jbosstools-build/parent

# Disable modules that fail to build
## tests
disable_tests_module="base base/common base/runtime base/usage base/stacks base/foundation \
               server/archives server/jmx server/as server/wtp \
               jst webservices javaee/cdi freemarker openshift"
for pom in ${disable_tests_module}; do %pom_disable_module tests jbosstools-${pom}; done
## site
disable_site_module="base server jst webservices javaee freemarker openshift"
for pom in ${disable_site_module}; do %pom_disable_module site jbosstools-${pom}; done
## base
%pom_disable_module org.jboss.tools.common.mylyn jbosstools-base/common/plugins
%pom_disable_module org.jboss.tools.common.mylyn.test jbosstools-base/common/tests
%pom_disable_module org.jboss.tools.common.mylyn.feature jbosstools-base/common/features
%pom_disable_module org.jboss.tools.common.all.test.feature jbosstools-base/common/features
%pom_disable_module org.jboss.tools.usage.test.feature jbosstools-base/usage/features
%pom_disable_module org.jboss.tools.runtime.test.feature jbosstools-base/runtime/features
%pom_disable_module org.jboss.tools.stacks.core.test.feature jbosstools-base/stacks/features
%pom_disable_module org.jboss.tools.foundation.test.feature jbosstools-base/foundation/features
## server
%pom_disable_module org.jboss.ide.eclipse.archives.test.feature jbosstools-server/archives/features
%pom_disable_module org.jboss.tools.jmx.test.feature jbosstools-server/jmx/features
%pom_disable_module org.jboss.ide.eclipse.as.test.feature jbosstools-server/as/features
%pom_disable_module org.jboss.tools.wtp.runtimes.tomcat.tests.feature jbosstools-server/wtp/features
## jst
%pom_disable_module org.jboss.tools.jst.test.feature jbosstools-jst/features
%pom_disable_module org.jboss.tools.jst.jsdt jbosstools-jst/plugins
%pom_disable_module org.jboss.tools.jst.jsdt.feature jbosstools-jst/features
%pom_disable_module org.jboss.tools.jst.angularjs.feature jbosstools-jst/features
## webservices
%pom_disable_module org.jboss.tools.ws.test.feature jbosstools-webservices/features
## javaee
%pom_disable_module jsf jbosstools-javaee
%pom_disable_module seam jbosstools-javaee
%pom_disable_module org.jboss.tools.cdi.test.feature jbosstools-javaee/cdi/features
%pom_disable_module org.jboss.tools.cdi.seam.test.feature jbosstools-javaee/cdi/features
%pom_disable_module org.jboss.tools.cdi.deltaspike.test.feature jbosstools-javaee/cdi/features
## freemarker
%pom_disable_module org.jboss.ide.eclipse.freemarker.test.feature jbosstools-freemarker/features
## openshift
%pom_disable_module org.jboss.tools.openshift.egit.integration.test.feature jbosstools-openshift/features
%pom_disable_module org.jboss.tools.openshift.express.test.feature jbosstools-openshift/features

%patch10 -p0
%patch12 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0

# In F22+, swt-chart is packaged as an Eclipse dropin
%if 0%{?fedora} >= 22
%patch30 -p0
%else
pushd jbosstools-server/jmx/plugins/org.jboss.tools.jmx.jvmmonitor.ui/lib/
ln -s %{_javadir}/swt-chart.jar
sed -i -e "s/org.swtchart_0.7.0.v20100930.jar/swt-chart.jar/" ../META-INF/MANIFEST.MF
popd
%endif

# Add Fedora version to OSGi version qualifier
%pom_xpath_remove pom:project/pom:build/pom:plugins/pom:plugin/pom:configuration/pom:format jbosstools-build/parent
%pom_xpath_inject pom:project/pom:build/pom:plugins/pom:plugin/pom:configuration "<format>'v'yyyyMMdd-HHmm'-\${BUILD_ALIAS}-F%{fedora}'</format>" jbosstools-build/parent

# Set tycho version to 0.18.0-SNAPSHOT in jbosstools-build/parent/pom.xml
sed -i -e 's|<tychoVersion>0.17.0</tychoVersion>|<tychoVersion>0.18.0</tychoVersion>|g' jbosstools-build/parent/pom.xml

# Version hasn't been updated to 4.2.0.Final-SNAPSHOT for all yet
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag}-SNAPSHOT jbosstools-base/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag}-SNAPSHOT jbosstools-build-sites/aggregate/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag}-SNAPSHOT jbosstools-freemarker/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag}-SNAPSHOT jbosstools-javaee/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag}-SNAPSHOT jbosstools-jst/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag}-SNAPSHOT jbosstools-openshift/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag}-SNAPSHOT jbosstools-server/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag}-SNAPSHOT jbosstools-webservices/pom.xml

sed -i -e "s/xpp3.jar/xpp3_min.jar/" jbosstools-webservices/plugins/org.jboss.tools.ws.wise.ui/build.properties

# Disable maven-download-plugin
%pom_remove_plugin com.googlecode.maven-download-plugin:maven-download-plugin jbosstools-base/foundation/plugins/org.jboss.tools.foundation.core

# TODO: Needs to be a git repo for tycho
git init
git config user.email "eclipse-jbosstools@fedoraproject.org"
git config user.name "Eclipse JBoss Tools Package"
git add .
git commit -m "Commit all the things for tycho"

%build
export MAVEN_OPTS="-XX:CompileCommand=exclude,org/eclipse/tycho/core/osgitools/EquinoxResolver,newState ${MAVEN_OPTS}"

xmvn -o -f jbosstools-build/parent/pom.xml install -Dlocal.site=file:.m2/p2/repo

xmvn -o -f jbosstools-base install -Dno-target-platform -X -Dmaven.local.debug=true \
             -Dlocal.site=file:.m2/p2/repo
xmvn -o -f jbosstools-server install -Dno-target-platform -X -Dmaven.local.debug=true \
             -Dlocal.site=file:.m2/p2/repo
xmvn -o -f jbosstools-openshift install -Dno-target-platform -X -Dmaven.local.debug=true \
             -Dlocal.site=file:.m2/p2/repo
xmvn -o -f jbosstools-webservices install -Dno-target-platform -X -Dmaven.local.debug=true \
             -Dlocal.site=file:.m2/p2/repo
xmvn -o -f jbosstools-freemarker install -Dno-target-platform -X -Dmaven.local.debug=true \
             -Dlocal.site=file:.m2/p2/repo
xmvn -o -f jbosstools-jst install -Dno-target-platform -X -Dmaven.local.debug=true \
             -Dlocal.site=file:.m2/p2/repo
xmvn -o -f jbosstools-javaee install -Dno-target-platform -X -Dmaven.local.debug=true \
             -Dlocal.site=file:.m2/p2/repo


%install
# jbosstools-base
pushd jbosstools-base
  for tool in common foundation runtime stacks usage; do
    install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/features
    install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/plugins

    ## features
    pushd ${tool}/features
      for feat in `echo *.feature`; do
        if [[ -d ${feat}/target ]]; then
          unzip ${feat}/target/*-SNAPSHOT.jar -d \
            %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/features/${feat}
        fi
      done;
    popd

    ##plugins
    install -p ${tool}/plugins/*/target/*-SNAPSHOT.jar \
      %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/plugins
  done
popd

# jbosstools-javaee
pushd jbosstools-javaee/cdi
  install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-cdi/eclipse/features
  install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-cdi/eclipse/plugins

  ## features
  unzip features/org.jboss.tools.cdi.deltaspike.feature/target/*-SNAPSHOT.jar \
   -d %{buildroot}%{eclipse_dropins}/%{name}-cdi/eclipse/features/org.jboss.tools.cdi.deltaspike.feature

  unzip features/org.jboss.tools.cdi.feature/target/*-SNAPSHOT.jar \
   -d %{buildroot}%{eclipse_dropins}/%{name}-cdi/eclipse/features/org.jboss.tools.cdi.feature

  unzip features/org.jboss.tools.cdi.seam.feature/target/*-SNAPSHOT.jar \
   -d %{buildroot}%{eclipse_dropins}/%{name}-cdi/eclipse/features/org.jboss.tools.cdi.seam.feature

  ##plugins
  install -p plugins/*/target/*-SNAPSHOT.jar %{buildroot}%{eclipse_dropins}/%{name}-cdi/eclipse/plugins
popd


# jbosstools-jst
install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-jst/eclipse/features
install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-jst/eclipse/plugins

## features
pushd jbosstools-jst/features
  for feat in `echo *.feature`; do
    if [[ -d ${feat}/target ]]; then
      unzip ${feat}/target/*-SNAPSHOT.jar -d %{buildroot}%{eclipse_dropins}/%{name}-jst/eclipse/features/${feat}
    fi
  done;
popd

##plugins
install -p jbosstools-jst/plugins/*/target/*-SNAPSHOT.jar %{buildroot}%{eclipse_dropins}/%{name}-jst/eclipse/plugins

# jbosstools-server
for tool in archives as jmx; do
  install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/features
  install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/plugins

  pushd jbosstools-server/${tool}
    ## features
    for feat in `ls -d features/*.feature | grep -v test`; do
      unzip ${feat}/target/*-SNAPSHOT.jar -d %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/${feat}
    done
  popd
done

## plugins
install -p jbosstools-server/jmx/plugins/*/target/*-SNAPSHOT.jar %{buildroot}%{eclipse_dropins}/%{name}-jmx/eclipse/plugins

pushd jbosstools-server/archives/plugins/
  for plug in $(ls -d */ | grep -v org.jboss.ide.eclipse.archives.core); do
    install -p ${plug}/target/*-SNAPSHOT.jar \
      %{buildroot}%{eclipse_dropins}/%{name}-archives/eclipse/plugins
  done

  # org.jboss.ide.eclipse.archives.core
  pushd org.jboss.ide.eclipse.archives.core/target
    unjar=$(ls *-SNAPSHOT.jar | sed -e 's/.jar//')
    unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-archives/eclipse/plugins/${unjar} ${unjar}.jar
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-archives/eclipse/plugins/${unjar}/lib
    rm -f *.jar
    ln -s %{_javadir}/truezip/truezip-driver-file.jar
    ln -s %{_javadir}/truezip/truezip-driver-zip.jar
    ln -s %{_javadir}/truezip/truezip-file.jar
    ln -s %{_javadir}/truezip/truezip-kernel.jar
  popd
popd

pushd jbosstools-server/as/plugins
  for plug in $(ls -d */); do
    install -p ${plug}/target/*-SNAPSHOT.jar %{buildroot}%{eclipse_dropins}/%{name}-as/eclipse/plugins
  done
  pushd %{buildroot}%{eclipse_dropins}/%{name}-as/eclipse/plugins

    unjar=$(ls org.jboss.ide.eclipse.as.dmr-*.jar | sed -e 's/.jar//')
    unzip -q -d ${unjar} ${unjar}.jar
    rm -f ${unjar}.jar
    rm -f ${unjar}/*.jar
    ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar ${unjar}/jboss-dmr.jar

    unjar=$(ls org.jboss.ide.eclipse.as.core-*.jar | sed -e 's/.jar//')
    unzip -q -d ${unjar} ${unjar}.jar
    rm -f ${unjar}.jar
    pushd ${unjar}
      rm -f *.jar
      ln -s %{_javadir}/dom4j.jar
      ln -s %{_javadir}/jaxen.jar
      ln -s %{_javadir}/gnu-getopt.jar
    popd

    unjar=$(ls org.jboss.ide.eclipse.as.management.as71-*.jar | sed -e 's/.jar//')
    unzip -q -d ${unjar} ${unjar}.jar
    rm -f ${unjar}.jar
    pushd ${unjar}
      rm -f *.jar
      ln -s %{_javadir}/wildfly/wildfly-controller-client.jar
      ln -s %{_javadir}/wildfly/wildfly-protocol.jar
      ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
      ln -s %{_javadir}/jboss-logging/jboss-logging.jar
      ln -s %{_javadir}/jboss-marshalling/jboss-marshalling.jar
      ln -s %{_javadir}/jboss-marshalling/jboss-marshalling-river.jar
      ln -s %{_javadir}/jboss-remoting/jboss-remoting.jar
      ln -s %{_javadir}/jboss-sasl/jboss-sasl.jar
      ln -s %{_javadir}/jboss-threads/jboss-threads.jar
      ln -s %{_javadir}/xnio/xnio-api.jar
      ln -s %{_javadir}/xnio/xnio-nio.jar
    popd
  popd
popd

# jbosstools-webservices
install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/features
install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/plugins

## features
pushd jbosstools-webservices/features
  for feat in `echo *.feature`; do
    if [[ -d ${feat}/target ]]; then
      unzip ${feat}/target/*-SNAPSHOT.jar -d %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/features/${feat}
    fi
  done;
popd

##plugins
install -p jbosstools-webservices/plugins/*/target/*-SNAPSHOT.jar %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/plugins
pushd %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/plugins
  unjar=$(ls org.jboss.tools.ws.ui-*.jar | sed -e 's/.jar//')
  unzip -q -d ${unjar} ${unjar}.jar
  rm -f ${unjar}.jar
  pushd ${unjar}/lib/
    rm -f *.jar
    ln -s %{_javadir}/axis/axis.jar
    ln -s %{_javadir}/axis/jaxrpc.jar
    ln -s %{_javadir}/resteasy/jaxrs-api.jar
  popd

  unjar=$(ls org.jboss.tools.ws.wise.ui-*.jar | sed -e 's/.jar//')
  unzip -q -d ${unjar} ${unjar}.jar
  rm -f ${unjar}.jar
  pushd ${unjar}/lib/
    rm -f *.jar
    ln -s %{_javadir}/ant.jar
    ln -s %{_javadir}/ant-launcher.jar
    ln -s %{_javadir}/objectweb-asm/asm.jar
    ln -s %{_javadir}/objectweb-asm/asm-tree.jar
    ln -s %{_javadir}/objectweb-asm/asm-util.jar
    ln -s %{_javadir}/avalon-framework-api.jar
    ln -s %{_javadir}/avalon-logkit.jar
    ln -s %{_javadir}/batik/batik-ext.jar
    ln -s %{_javadir}/codemodel.jar
    ln -s %{_javadir}/commons-codec.jar
    ln -s %{_javadir}/commons-collections.jar
    ln -s %{_javadir}/commons-httpclient.jar
    ln -s %{_javadir}/commons-io.jar
    ln -s %{_javadir}/commons-lang.jar
    ln -s %{_javadir}/commons-logging.jar
    ln -s %{_javadir}/cxf/cxf-api.jar
    ln -s %{_javadir}/cxf/cxf-rt-bindings-coloc.jar
    ln -s %{_javadir}/cxf/cxf-rt-bindings-object.jar
    ln -s %{_javadir}/cxf/cxf-rt-bindings-soap.jar
    ln -s %{_javadir}/cxf/cxf-rt-bindings-xml.jar
    ln -s %{_javadir}/cxf/cxf-rt-core.jar
    ln -s %{_javadir}/cxf/cxf-rt-databinding-jaxb.jar
    ln -s %{_javadir}/cxf/cxf-rt-frontend-jaxws.jar
    ln -s %{_javadir}/cxf/cxf-rt-frontend-simple.jar
    ln -s %{_javadir}/cxf/cxf-rt-transports-http.jar
    ln -s %{_javadir}/cxf/cxf-rt-transports-local.jar
    ln -s %{_javadir}/cxf/cxf-rt-ws-addr.jar
    ln -s %{_javadir}/cxf/cxf-rt-ws-mex.jar
    ln -s %{_javadir}/cxf/cxf-rt-ws-policy.jar
    ln -s %{_javadir}/cxf/cxf-services-ws-discovery-api.jar
    ln -s %{_javadir}/cxf/cxf-tools-common.jar
    ln -s %{_javadir}/cxf/cxf-tools-validator.jar
    ln -s %{_javadir}/cxf/cxf-tools-wsdlto-core.jar
    ln -s %{_javadir}/cxf/cxf-tools-wsdlto-databinding-jaxb.jar
    ln -s %{_javadir}/cxf/cxf-tools-wsdlto-frontend-jaxws.jar
    ln -s %{_javadir}/cxf-xjc-utils/cxf-xjc-boolean.jar
    ln -s %{_javadir}/cxf-xjc-utils/cxf-xjc-dv.jar
    ln -s %{_javadir}/cxf-xjc-utils/cxf-xjc-ts.jar
    ln -s %{_javadir}/dtdparser.jar
    ln -s %{_javadir}/freemarker.jar
    ln -s %{_javadir}/hsqldb.jar
    ln -s %{_javadir}/istack-commons-runtime.jar
    ln -s %{_javadir}/istack-commons-tools.jar
    ln -s %{_javadir}/gnu-getopt.jar java-getopt.jar
    ln -s %{_javadir}/javassist.jar
    ln -s %{_javadir}/glassfish-jaxb/jaxb-impl.jar
    ln -s %{_javadir}/glassfish-jaxb/jaxb-xjc.jar
    ln -s %{_javadir}/jaxen.jar
    ln -s %{_javadir}/jboss-jaxb-2.2-api.jar jboss-jaxb-api_2.2_spec.jar
    ln -s %{_javadir}/jboss-jaxrpc-1.1-api/jboss-jaxrpc-api_1.1_spec.jar
    ln -s %{_javadir}/jboss-jaxws-2.2-api/jboss-jaxws-api_2.2_spec.jar
    ln -s %{_javadir}/jboss-logging/jboss-logging.jar
    ln -s %{_javadir}/jboss-saaj-1.3-api.jar jboss-saaj-api_1.3_spec.jar
    ln -s %{_javadir}/jboss-servlet-3.0-api/jboss-servlet-api_3.0_spec.jar
    ln -s %{_javadir}/jbossws-api/jbossws-api.jar
    ln -s %{_javadir}/jbossws-common/jbossws-common.jar
    ln -s %{_javadir}/jbossws-common-tools/jbossws-common-tools.jar
    ln -s %{_javadir}/jbossws-cxf/jbossws-cxf-client.jar
    ln -s %{_javadir}/jbossws-cxf/jbossws-cxf-factories.jar
    ln -s %{_javadir}/jbossws-cxf/jbossws-cxf-transports-udp.jar
    ln -s %{_javadir}/jbossws-spi/jbossws-spi.jar
    ln -s %{_javadir}/jms.jar
    ln -s %{_javadir}/jta.jar
    ln -s %{_javadir}/log4j.jar
    ln -s %{_javadir}/javamail/mail.jar
    ln -s %{_javadir}/smooks/milyn-commons.jar
    ln -s %{_javadir}/smooks/milyn-smooks-core.jar
    ln -s %{_javadir}/smooks/milyn-smooks-javabean.jar
    ln -s %{_javadir}/smooks/milyn-smooks-rules.jar
    ln -s %{_javadir}/smooks/milyn-smooks-validation.jar
    ln -s %{_javadir}/mvel.jar
    ln -s %{_javadir}/neethi.jar
    ln -s %{_javadir}/opencsv.jar
    ln -s %{_javadir}/rngom.jar
    ln -s %{_javadir}/servlet.jar servlet-api.jar
    ln -s %{_javadir}/stax2-api.jar stax-api.jar
    ln -s %{_javadir}/txw2.jar
    ln -s %{_javadir}/velocity.jar
    ln -s %{_javadir}/wise/wise-core-cxf.jar
    ln -s %{_javadir}/wise/wise-core.jar
    ln -s %{_javadir}/xml-commons-apis.jar xml-apis.jar
    ln -s %{_javadir}/ws-xmlschema/xmlschema-core.jar
    ln -s %{_javadir}/xpp3-minimal.jar xpp3.jar
    ln -s %{_javadir}/xsom.jar
    ln -s %{_javadir}/xstream.jar
  popd
popd

# jbosstools-freemarker
install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-freemarker/eclipse/features
install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-freemarker/eclipse/plugins

## features
pushd jbosstools-freemarker/features
  unzip org.jboss.ide.eclipse.freemarker.feature/target/*-SNAPSHOT.jar \
   -d %{buildroot}%{eclipse_dropins}/%{name}-freemarker/eclipse/features/org.jboss.ide.eclipse.freemarker.feature
popd

##plugins
pushd jbosstools-freemarker/plugins/org.jboss.ide.eclipse.freemarker/target
  unjar=$(ls org.jboss.ide.eclipse.freemarker-*-SNAPSHOT.jar | sed -e 's/.jar//')
  unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-freemarker/eclipse/plugins/${unjar} ${unjar}.jar
  rm -f ${unjar}.jar
  pushd %{buildroot}%{eclipse_dropins}/%{name}-freemarker/eclipse/plugins/${unjar}/
    rm -f freemarker.jar
    ln -s %{_javadir}/freemarker.jar
  popd
popd

# jbosstools-openshift
install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-openshift/eclipse/features
install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-openshift/eclipse/plugins

## features
pushd jbosstools-openshift/features
  for feat in `echo *.feature`; do
    if [[ -d ${feat}/target ]]; then
      unzip ${feat}/target/*-SNAPSHOT.jar -d %{buildroot}%{eclipse_dropins}/%{name}-openshift/eclipse/features/${feat}
    fi
  done
popd

##plugins
pushd jbosstools-openshift/plugins/
  for plug in $(ls -d */target/*-SNAPSHOT.jar |grep -v org.jboss.tools.openshift.express.client); do
    install -p ${plug} %{buildroot}%{eclipse_dropins}/%{name}-openshift/eclipse/plugins
  done
popd

pushd jbosstools-openshift/plugins/org.jboss.tools.openshift.express.client/target/
  unjar=$(ls org.jboss.tools.openshift.express.client-*-SNAPSHOT.jar | sed -e 's/.jar//')
  unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-openshift/eclipse/plugins/${unjar} ${unjar}.jar
  rm -f ${unjar}.jar
  pushd %{buildroot}%{eclipse_dropins}/%{name}-openshift/eclipse/plugins/${unjar}/lib
    rm -f *.jar
    ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
    ln -s %{_javadir}/log4j12-1.2.17.jar log4j.jar
    ln -s %{_javadir}/openshift-java-client/openshift-java-client.jar
    ln -s %{_javadir}/slf4j/api.jar slf4j-api.jar
    ln -s %{_javadir}/slf4j/log4j12.jar slf4j-log4j12.jar
    ln -s %{_javadir}/commons-compress.jar
  popd
popd

%files

%files common
%doc lgpl-2.1.txt
%doc jbosstools-base/tests/features/org.jboss.tools.test.feature/epl-v10.html
%{eclipse_dropins}/%{name}-common

%files usage
%doc LICENSE-2.0.txt
%doc jbosstools-base/tests/features/org.jboss.tools.test.feature/epl-v10.html
%{eclipse_dropins}/%{name}-usage

%files archives
%doc lgpl-2.1.txt
%{eclipse_dropins}/%{name}-archives

%files jmx
%doc jbosstools-base/tests/features/org.jboss.tools.test.feature/epl-v10.html
%{eclipse_dropins}/%{name}-jmx

%files as
%{eclipse_dropins}/%{name}-as

%files jst
%{eclipse_dropins}/%{name}-jst

%files cdi
%{eclipse_dropins}/%{name}-cdi

%files ws
%doc lgpl-2.1.txt
%{eclipse_dropins}/%{name}-ws

%files freemarker
%doc lgpl-2.1.txt
%{eclipse_dropins}/%{name}-freemarker

%files runtime
%{eclipse_dropins}/%{name}-runtime

%files foundation
%{eclipse_dropins}/%{name}-foundation

%files stacks
%{eclipse_dropins}/%{name}-stacks

%files openshift
%{eclipse_dropins}/%{name}-openshift

%changelog
* Sat Jan 24 2015 Gerard Ryan <galileo@fedoraproject.org> - 4.2.2-1
- Update to 4.2.2.Final

* Fri Nov 14 2014 Gerard Ryan <galileo@fedoraproject.org> - 4.2.0-2
- Rebuild now that Eclipse is fixed

* Sun Nov 09 2014 Gerard Ryan <galileo@fedoraproject.org> - 4.2.0-1
- Update to 4.2.0.Final

* Wed Jul 09 2014 Gerard Ryan <galileo@fedoraproject.org> - 4.2.0-0.1.Beta2
- Update to 4.2.0.Beta2 for Eclipse Luna & F21

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.1.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Fri Mar 28 2014 Michael Simacek <msimacek@redhat.com> - 4.1.1-3
- Use Requires: java-headless rebuild (#1067528)

* Fri Dec 20 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.1-2
- Update to 4.1.1.Final

* Wed Oct 02 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-7
- RHBZ-1014459: Unbundle jars from plugin bundles

* Tue Oct 01 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-6
- Re-add jbosstools-openshift subpackage

* Mon Sep 16 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-5
- RHBZ-1008307: Workaround for problem in arm which causes NPE

* Fri Sep 13 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-4
- Bump release to rebuild for f20
- Disable jacoco plugin in parent pom

* Sat Sep 07 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-3
- Update to use wildfly and updated jar locations

* Sun Aug 18 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-2
- Add org.jboss.tools.ws.wise.ui to ws package

* Sun Aug 18 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-1
- Update to latest upstream version 4.1.0 on f19+

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 4.0.0-2
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Tue Oct 16 2012 Gerard Ryan <galileo@fedoraproject.org> - 4.0.0-1
- Update to upstream 4.0.0.Final
- Add script create-tarball.sh to create source tarball from Git.
- Update locations for symlinked jars and POM macros.
- Remove unnecessary pom macros.

* Tue Oct 16 2012 Gerard Ryan <galileo@fedoraproject.org> - 4.0.0-0.2
- Update to tag jbosstools-4.0.0.Alpha2.
- Add subpackage runtime, necessary for 'as' subpackage.
- Shorten summary line.
- Rebase patches 14, 15, 16, 21, 23; append -4.0.0 to patch name.
- Remove patches 13, 20.
- Remove dependency on jbossxb.

* Mon Oct 08 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-5
- Build as a noarch package.

* Tue Sep 04 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-4
- Add Fedora version to OSGi version qualifier.

* Sat Aug 11 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-3
- Make build process more efficient & remove -Dmaven.test.skip option.
- Use pom macros, and remove patches that are no longer necessary.
- Add tests module to tarball.
- Add apache-commons-codec as BR.

* Thu Jul 26 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-2
- Fix license field and install license files.
- Use a clean tarball to reduce srpm size.
- Use spaces consistently; add some necessary comments.

* Thu Jul 26 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-1
- Initial packaging.
